<?php
/*
 * @package    twjtable
 * @subpackage twjtable/database
 * @author     Teo Super <plugins@teowin.nl>
 */
class twjtable_Database {

	/**
	 * The ID of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $plugin_name    The ID of this plugin.
	 */
	private $plugin_name;

	/**
	 * The version of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $version    The current version of this plugin.
	 */
	private $version;

	/**
	 * Initialize the class and set its properties.
	 *
	 * @since    1.0.0
	 * @param      string    $plugin_name       The name of the plugin.
	 * @param      string    $version    The version of this plugin.
	 */
	public function __construct( $plugin_name, $version ) {

		$this->plugin_name = $plugin_name;
		$this->version = $version;
	}

	public function list_entries() {
		//


		try {
			global $wpdb;
//	switch($_SERVER["REQUEST_METHOD"]) {
//		case "GET":
	//		{
				//Getting records (listAction)

			//See https://github.com/tabalinas/jsgrid/issues/84

				if ( $_GET["action"] == "list_entries" ) {
				$theformID = $_GET["formid"];

				$offset   = isset( $_REQUEST['pageIndex'] ) ? $_REQUEST['pageIndex'] : 1;
				$pagesize = isset( $_REQUEST['pageSize'] ) ? $_REQUEST['pageSize'] : 10;
			//	$q        = $_REQUEST['q'];
			//	$sort     = isset( $_REQUEST['jtSorting'] ) ? $_REQUEST['jtSorting'] : $this->db->primary . ' desc';
			//	$opt      = $_REQUEST['opt'];

				$fields = \FrmField::getAll( $wpdb->prepare( 'fi.form_id=%d', $theformID ) . " and fi.type not in ('end_divider', 'divider', 'html', 'break', 'captcha', 'rte')", ' ORDER BY field_order' );

				$querystring = 'SELECT ';
				$querystring .= 'itm.id,';
				$querystring .= 'fld.name, ';
				$querystring .= 'mta.meta_value, ';
				$querystring .= 'mta.field_id, ';
				$querystring .= 'fld.form_id AS \'FormID\' ';
				$querystring .= 'FROM ';
				$querystring .= $wpdb->prefix . 'frm_forms frm ';
				$querystring .= 'INNER JOIN ' . $wpdb->prefix . 'frm_fields fld ON fld.form_id = frm.id ';
				$querystring .= 'INNER JOIN ' . $wpdb->prefix . 'frm_items itm ON itm.form_id = frm.id ';
				$querystring .= 'LEFT JOIN  ' . $wpdb->prefix . 'frm_item_metas mta ON mta.field_id = fld.id AND mta.item_id = itm.id ';
				$querystring .= 'where ';
				$querystring .= 'frm.id = ' . $theformID;
				$querystring .= ' Group by ';
				$querystring .= 'itm.id, ';
				$querystring .= 'fld.name, ';
				$querystring .= 'mta.meta_value, ';
				$querystring .= 'mta.field_id ';
				$querystring .= 'ORDER BY ';
				$querystring .= 'itm.id  ';

				//Get records from database
				$result = $wpdb->get_results( $querystring );


				//Add all records to an array
				$rows = array();
				$rij  = array();

				foreach ( $result as $record => $dbfield ) {
					$rij[ $dbfield->id ][ $dbfield->name ] = $dbfield->meta_value;
				}

				$totalrecords = count($rij);

				foreach ( $rij as $key => $item) {

					$record = $item;
					$record['ID'] = $key;
					$rows[]       = $record;

				}

					$page = ! empty( $offset ) ? (int) $offset : 1;
					$total = count( $rij ); //total items in array
					$limit = $pagesize; //per page
					$totalPages = ceil( $total/ $limit ); //calculate total pages
					$page = max($page, 1); //get 1 page when $_GET['page'] <= 0
					$page = min($page, $totalPages); //get last page when $_GET['page'] > $totalPages
					$offset = ($page - 1) * $limit;
					if( $offset < 0 ) $offset = 0;

					$dbrecords = array_slice( $rows, $offset, $limit );

//$dbrecords = $rows;
				//Return result to jTable
				$jTableResult                     = array();
				$jTableResult['Result']           = "OK";
				$jTableResult['Records']          = $dbrecords;
				$jTableResult['TotalRecordCount'] = $totalrecords;

			   $result = $jTableResult;

			}

		//Creating a new record (createAction)
			else if ( $_GET["action"] == "create_entry" ) {

				$theformID = $_GET["formid"];

				$fields = \FrmField::getAll( $wpdb->prepare( 'fi.form_id=%d', $theformID ) . " and fi.type not in ('end_divider', 'divider', 'html', 'break', 'captcha', 'rte')", ' ORDER BY field_order' );

				$newmetas = array();

				$datafields = $_REQUEST;

		        foreach($fields as $thefield){
		            if ( array_key_exists($thefield->name, $datafields) )
		            {
			        	  $newmetas[$thefield->id] = $datafields[$thefield->name];
			        }

		        }

				global $user_ID;
				global $form_id;

				$form_id = $theformID;

				$entry =  array(
					'form_id'     => $theformID ,
					//	'item_key'    => 'entry',  // FrmAppHelper::get_unique_key( $new_key, $wpdb->prefix . 'frm_forms', 'form_key' ), //change entry to a dynamic value if you would like
					'frm_user_id' => get_current_user_id(),
					'item_meta'  => $newmetas,
				);

				//create entry
				$res = \FrmEntry::create( $entry );
                $result = $res;
			}

		//Updating a record (updateAction)
			else if ( $_GET["action"] == "update_entry" ) {

				$theformID = $_GET["formid"];

				$fields = \FrmField::getAll( $wpdb->prepare( 'fi.form_id=%d', $theformID ) . " and fi.type not in ('end_divider', 'divider', 'html', 'break', 'captcha', 'rte')", ' ORDER BY field_order' );

				$newmetas = array();

				$datafields = $_REQUEST;


				// Do the calculations here before the fields are saved.
                $formulafields = array();
				foreach($fields as $formfield){
					// Search the fields for the ones with a calculation.
					if ($formfield->field_options["use_calc"] === "1") {
						$str = $formfield->field_options["calc"];

						$matches = array();
						preg_match_all("/\[(.?)\b(.*?)(?:(\/))?\]/s", $str, $matches, PREG_PATTERN_ORDER);

					    // fill the second array element with the field values used in the calculation.
						for ( $i = 0; $i < sizeof($matches[0]); $i++  ) {
							$matches[1][ $i ] = $datafields[ $matches[2][ $i ] ];
						};

						// Replace the shortcodes in $str with the values.
						for ( $i = 0; $i < sizeof($matches[0]); $i++  ) {
						   $str = str_replace($matches[0][ $i ],  $matches[1][ $i ], $str);
						}

						// We have a new string, containing values.
						$Cal = new twjtable_calculate();

						$datafields[$formfield->name]  = $Cal->calculate($str);
					};
				};






				$itemkey = $datafields['ID'];
                // Get field ID's and entered values in one array.
				foreach($fields as $thefield){
					if ( array_key_exists(str_replace(' ', '_', $thefield->name), $datafields) )
					{
						$newmetas[$thefield->id] = $datafields[str_replace(' ', '_', $thefield->name)];
					}

				}


				$new_values = array(
					'form_id' => $theformID,
				    'updated_at' => current_time( 'mysql', 1 ),
		         	'updated_by' => get_current_user_id(),
				);

				$res = -1;
			    $updateresult =	\FrmEntry::update($itemkey, $new_values);
			    if ($updateresult === 1) {
				    $res = \FrmEntryMeta::update_entry_metas( $itemkey, $newmetas );
			    }
				$result = $res;



                $jTableResult  = array();
				$jTableResult['data']   = $newmetas;
				$jTableResult['Result'] = "OK";

				ob_clean();
				echo json_encode( $jTableResult );
				wp_die();
			}

		//Deleting a record (deleteAction)
			else if ( $_GET["action"] == "delete_entry" ) {

				$datafields = $_REQUEST;

				$itemkey = $datafields['ID'];

                $res = \FrmEntry::destroy($itemkey);

				//Return result to jTable
				if ($res == 1) {
					$jTableResult           = $datafields;
					$jTableResult['Result'] = "OK";

				}
				else {
					$jTableResult['Result'] = "FAIL";
				}
				ob_clean();
				echo json_encode( $jTableResult );
				wp_die();
		//	}


	}
		} catch
		( Exception $ex ) {
			//Return error message
			$jTableResult            = array();
			$jTableResult['Result']  = "ERROR";
			$jTableResult['Message'] = $ex->getMessage();
			print json_encode( $jTableResult );
		}

		header("Content-Type: application/json");
		ob_clean();
		echo json_encode( $result );
		wp_die();
	}

	public static function load_select(){
		if ( $_GET["action"] == "load_select" ) {
			$theformID = $_GET["formid"];

			$offset = isset( $_REQUEST['fieldID'] ) ? $_REQUEST['pageIndex'] : 1;
			//	$pagesize = isset( $_REQUEST['pageSize'] ) ? $_REQUEST['pageSize'] : 10;
		}
	}

	public static function getformfields($formid, $listurl, &$fieldscript, &$formname, $columnwidths, $editing ){

		global $wpdb;

	    $theform = \FrmForm::getOne($formid);
		$fields = \FrmField::getAll( $wpdb->prepare( 'fi.form_id=%d', $formid ) . " and fi.type not in ('end_divider', 'divider', 'html', 'break', 'captcha', 'rte')", ' ORDER BY field_order' );

        $formname = $theform->name;
		$fieldsettings = array();
		$fieldscript = '[ {name: "ID", align: "right", width: "10%", visible: false }, ';

		$fieldsettings[] = array('name' => 'ID');

		foreach($fields as $formfield) {

			$fieldname = $formfield->name;

			// Version 1.1
			if (! array_key_exists($fieldname, $columnwidths)){

			    if ( $formfield->required == "1")
			    {
			    	$editing = false;
			    }

				continue;
			}

		//	{ name: "Name", type: "text", width: "30%", validate: "required" },

			$fieldkind = $formfield->type;

			$fieldsetting = array();

         //   $fieldsetting['name'] = $formfield->name;

			$fieldscript .= ' { name: "' . $formfield->name . '",';

			if (array_key_exists($formfield->name, $columnwidths)) {
				// width of the column(s) is set in the shortcode.
			   $fieldscript .= ' width: "' .	$columnwidths[$formfield->name] . '", ';
			}


			if ( $formfield->required == "1")
			{

				$fieldsetting['validate'] = array(
					                               "validator" => "required",
												   "message" => "Field $formfield->name is required");

				$fieldscript .= 'validate : "required", message: "Field ' . $formfield->name . ' is required", ';
			};


			if (isset($formfield->field_options["use_calc"])) {
				if ( $formfield->field_options["use_calc"] === "1" ) {  // if formfield has a calculated value
					$fieldscript .= ' editing : false, 
				                  inserting : false,
				                  itemTemplate: function(value, item) {
				                               // Probably want to add rounding and error checking on this and maybe even some nice formatting
				                                
				                                return item.Aantal * item.Bedrag;
			                                   }, ';

				}
			}



			switch ($fieldkind) {
				case "text":{
					$fieldscript .= 'type : "text" ';
					break;
			    	}
				case "number":{
					$fieldscript .= 'type : "number", ';
				//	$fieldscript .= 'align : "right" ';
				//	$fieldscript .= 'width : "10%" ';
					break;
				}
				case "select":{
					$fieldscript .= 'type: "select",  align: "left", autosearch: "true",	';
					$options = array();
                    $theOptions = $formfield->options;

                    $fieldscript .= 'items: [';
					foreach ( $theOptions as $key => $value) {
						$options[ $value['label'] ] = $value['value'];
						if (! $value['label'] == '') {
							$fieldscript .= ' {Name: "' . $value['label'] . '", Id: "' . $value['value'] . '"},';
						}
						else {
							$fieldscript .= ' {Name: "",  Id: "" },';
						}

					}
					$fieldscript .= '], ';
                    $fieldscript .= ' valueType: "string", 
                                      valueField: "Id",
                                      textField: "Name"';

                    break;
				    }
				case "email":
					{
						$fieldscript .= ' type: "text",';
						break;
					}
				case "textarea":
					{
						$fieldscript .= ' type: "textarea",';
						break;
					}
				case "userid":
					{
						$fieldscript .= ' type : "number",';
						$fieldscript .= ' sorter : "number",';
						$fieldscript .= ' align : "right",';
						$fieldscript .= ' readonly : "false",';
						break;
					}
			}

		//	$newmetas[] = array('name' => $FormField->name,  "type" => "text");
	//		$fieldsettings[] = $fieldsetting;
		//	unset($fieldsetting);
           $fieldscript .= '}, ';
		}

   //      $fieldsettings[] = array('type' => 'control');

		$fieldscript .= ' { type : "control", width : "5%"} ';
		$fieldscript .= ']';

	//	$fieldsettings = json_encode($fieldsettings);

	//	return array('200' => 'OK');

	}

}