<?php

/**
 * @link              http://teowin-software.nl
 * @since             0.9
 * @package           twjtable
 *
 * @wordpress-plugin
 * Plugin Name:       Teowin Grid for Formidable Pro
 * Plugin URI:        https://teowin-software.nl.
 * Description:       Teowin Datagrid displays Formidable Pro entries in a responsive inline editable grid that is highly customizeable.
 * Version:           1.1
 * Author:            Teo Super
 * Author URI:        https://www.teowin-software.nl
 * Text Domain:       teowingrid
 * Domain Path:       /languages
 *
 * This software is subject to the GPL 2.0 license that is included with this plugin.
 * Teowin grants you the right to use and modify the software according to the GPL license, provided that
 * you don't sell, lease, rent, loan or give this software or sell support or maintenance.
 * Teowin does not support this software, does not provide bugfixes, does not anwer question or helps to recover, restore or set up
 * or provides any help if you did not have a reqular support license which you bought with us directely.
 * At this moment in time (january 2019) there are NO parties selling, renting or supporting our pluging.
 * In case that policy changes, you should be able to find our resellers/partners listed on our website.
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

define('TWGRID_WOO_PATH',   plugin_dir_path(__FILE__));
define('TWGRID_WOO_URL',    plugins_url('', __FILE__));

define('TWGRID_WOO_APP_API_URL',  'https://www.teowin-software.nl/index.php');
define('TWGRID_WOO_APP_URL',  'https://www.teowin-software.nl');

define('TWGRID_WOO_PLUGIN_NAME', 'teowingrid-for-formidable-pro.php');

define('TWGRID_FULL_NAME', 'teowingrid for formidable pro/' . TWGRID_WOO_PLUGIN_NAME);

//the Software Unique ID as defined within product admin page
define('TWGRID_WOO_PRODUCT_ID', 'twGridFrmPro');

//A code variable constant is required, which is the user application code version. This will be used by API to compare against the new version on shop server.
define('TWGRID_WOO_VERSION', '1.0');

$protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
define('TWGRID_WOO_INSTANCE',             str_replace($protocol, "", get_bloginfo('wpurl')));

include(TWGRID_WOO_PATH . '/include/class.wooslt.php');
include(TWGRID_WOO_PATH . '/include/class.licence.php');
include(TWGRID_WOO_PATH . '/include/class.options.php');
include(TWGRID_WOO_PATH . '/include/class.updater.php');



// require_once plugin_dir_path(__FILE__) . 'update/twgridupdater.php';

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-twjtable-activator.php
 */
function activate_twjtable() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-twjtable-activator.php';
	twjtable_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-twjtable-deactivator.php
 */
function deactivate_twjtable() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-twjtable-deactivator.php';
	twjtable_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_twjtable' );
register_deactivation_hook( __FILE__, 'deactivate_twjtable' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-twjtable-plugin.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_twjtable() {

	global $TWGRID_WOO;
	$TWGRID_WOO = new TWGRID_WOO();

	$plugin = new twjtable();
	$plugin->run();

}
run_twjtable();


